/*
 * Subset of Influx API covered by Influx CLI
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * API version: 2.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package api

import (
	"encoding/json"
)

// CreateDashboardRequest struct for CreateDashboardRequest
type CreateDashboardRequest struct {
	// The ID of the organization that owns the dashboard.
	OrgID string `json:"orgID" yaml:"orgID"`
	// The user-facing name of the dashboard.
	Name string `json:"name" yaml:"name"`
	// The user-facing description of the dashboard.
	Description *string `json:"description,omitempty" yaml:"description,omitempty"`
}

// NewCreateDashboardRequest instantiates a new CreateDashboardRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateDashboardRequest(orgID string, name string) *CreateDashboardRequest {
	this := CreateDashboardRequest{}
	this.OrgID = orgID
	this.Name = name
	return &this
}

// NewCreateDashboardRequestWithDefaults instantiates a new CreateDashboardRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateDashboardRequestWithDefaults() *CreateDashboardRequest {
	this := CreateDashboardRequest{}
	return &this
}

// GetOrgID returns the OrgID field value
func (o *CreateDashboardRequest) GetOrgID() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrgID
}

// GetOrgIDOk returns a tuple with the OrgID field value
// and a boolean to check if the value has been set.
func (o *CreateDashboardRequest) GetOrgIDOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrgID, true
}

// SetOrgID sets field value
func (o *CreateDashboardRequest) SetOrgID(v string) {
	o.OrgID = v
}

// GetName returns the Name field value
func (o *CreateDashboardRequest) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CreateDashboardRequest) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CreateDashboardRequest) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *CreateDashboardRequest) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateDashboardRequest) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *CreateDashboardRequest) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *CreateDashboardRequest) SetDescription(v string) {
	o.Description = &v
}

func (o CreateDashboardRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["orgID"] = o.OrgID
	}
	if true {
		toSerialize["name"] = o.Name
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	return json.Marshal(toSerialize)
}

type NullableCreateDashboardRequest struct {
	value *CreateDashboardRequest
	isSet bool
}

func (v NullableCreateDashboardRequest) Get() *CreateDashboardRequest {
	return v.value
}

func (v *NullableCreateDashboardRequest) Set(val *CreateDashboardRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateDashboardRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateDashboardRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateDashboardRequest(val *CreateDashboardRequest) *NullableCreateDashboardRequest {
	return &NullableCreateDashboardRequest{value: val, isSet: true}
}

func (v NullableCreateDashboardRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateDashboardRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
